'use strict';
var yeoman = require('yeoman-generator');

module.exports = yeoman.generators.Base.extend({

	constructor: function() {

		yeoman.generators.Base.apply(this, arguments);

		this.option('name', {
			desc: 'The name of this app.',
			type: String,
			default: this.appname
		});

		this.option('install', {
			desc: 'Installs dependencies automatically',
			type: Boolean,
			default: false
		});

		this.appname = (this.options.name ? this.options.name : this.appname);

	},
	initializing: function() {
		this.pkg = require('../package.json');
	},
	writing: function() {
		this.fs.copyTpl(
			this.templatePath('_src'),
			this.destinationPath('src'), {
				name: this.appname
			}
		);
		this.fs.copyTpl(
			this.templatePath('_package.json'),
			this.destinationPath('package.json'), {
				name: this.appname
			}
		);
		this.fs.copyTpl(
			this.templatePath('_bower.json'),
			this.destinationPath('bower.json'), {
				name: this.appname
			}
		);
		this.fs.copy(
			this.templatePath('editorconfig'),
			this.destinationPath('.editorconfig')
		);
		this.fs.copy(
			this.templatePath('jshintrc'),
			this.destinationPath('.jshintrc')
		);
		this.fs.copyTpl(
			this.templatePath('_gulpfile.js'),
			this.destinationPath('gulpfile.js'), {
				name: this.appname
			}
		);

	},
	install: function() {

		this.installDependencies({
			skipInstall: !this.options.install
		});
	}

});
